#include <cassert>
#include <cstdio>
#include <cstring>
#include <fstream>
#include <iostream>
#include <string>
#include <vector>

using namespace std;

#ifdef DISABLE_BASH_COLOUR_CODING
	const string beginMessage, endMessage, beginError, endError, beginWarning, endWarning;
#else
	const string beginMessage = "\033[37m";
	const string endMessage = "\033[0m";
	const string beginError = "\033[31;1m";
	const string endError = endMessage;
	const string beginWarning = "\033[31;4m";
	const string endWarning = endMessage;
#endif

int totalNumCases = 0;
vector<string> lines;

bool doReadFile(string filename) {
	ifstream fin(filename.c_str());
	if (fin.fail()) {
		cerr << beginError << "Error: failed to open file \"" << filename << "\"." << endError << endl;
		return false;
	}
	string str;
	int numCases;
	getline(fin, str);
	sscanf(str.c_str(), "%d", &numCases);
	char tmp[20];
	sprintf(tmp, "%d", numCases);
	assert(!strcmp(str.c_str(), tmp));
	totalNumCases += numCases;
	while (getline(fin, str))
		lines.push_back(str);
	return true;
}

int main(int argc, char *argv[]) {
	cerr << beginMessage << "Merging files:" << endMessage << endl;
	for (int i = 1; i < argc; i++) {
		cerr << beginMessage << " " << argv[i] << ": " << (doReadFile((string) argv[i]) ? "OK" : "fail") << endMessage << endl;
	}
	cout << totalNumCases << endl;
	for (vector<string>::iterator it = lines.begin(); it != lines.end(); it++) {
		cout << *it << endl;
	}
	return 0;
}
