#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <cctype>
#include <climits>
#include <cassert>

#include <vector>
#include <deque>
#include <queue>
#include <stack>
#include <list>
#include <set>
#include <map>
#include <string>

#include <iostream>
#include <sstream>

#include <utility>
#include <functional>
#include <limits>
#include <numeric>
#include <algorithm> 

using namespace std;

long long M, N, s, Modulus;
long long subsum[512];
bool played[512][512];
bool considered[512];
set<int> someway[512];

void processcomp(set<int> settemp) {
	for (int i = 511-s; i >= 0; i--) {
		subsum[i+s] += subsum[i];
		subsum[i+s] %= Modulus;
		if ((subsum[i] > 0) && (someway[i+s].empty()))
			someway[i+s] = settemp;
	}
}

set<int> floodfill(int i) {
	//cerr << "floodfill(" << i << ")\n";
	set<int> ans;
	ans.insert(i);
	considered[i] = true;
	s += 1;
	for (int j = 1; j <= N; j++)
	if ((considered[j] == false) && (played[i][j] == false)) {
		set<int> tempset = floodfill(j);
		ans.insert(tempset.begin(), tempset.end());
	}
	return ans;
}

void doit() {
	Modulus = 100000000;
	cin >> N >> M;
	N *= 2;
	for (int i = 1; i <= N; i++) {
		subsum[i-1] = 0;
		someway[i-1].clear();
		considered[i] = false;
		for (int j = 1; j <= N; j++)
			played[i][j] = false;
	}
	for (int i = 0; i < M; i++) {
		int A, B;
		cin >> A >> B;
		played[A][B] = true;
		played[B][A] = true;
		//cerr << A << " and " << B << " played\n";		
	}
	for (int i = 1; i <= N; i++)
	if (considered[i] == false) {
		s = 0;
		set<int> settemp = floodfill(i);
		//cerr << "Found component of size " << s << '\n';
		if (i == 1) {
			subsum[s] = 1;
			someway[s] = settemp;
		} else {
			processcomp(settemp);
		}
	}
	if (subsum[N/2] > 1)
		cout << subsum[N/2] << "\n";
	else {
		cout << "1\n";
	}
		set<int> settemp;
		while (settemp.size() < N/2) {
			set<int> toadd = someway[N/2 - settemp.size()];
			settemp.insert(toadd.begin(), toadd.end());
		}
		while (settemp.size() > 1) {
			cout << *(settemp.begin()) << ' ';
			settemp.erase(*settemp.begin());
		}
		cout << *settemp.begin() << '\n';
	
}

int main () {
	int T;
	cin >> T;
	for (int t = 1; t <= T; t++) {
		doit();
	}
	return 0;
}

