// @author Frank
// @opgave Ga

#include <cstring>
#include <iostream>
#include <vector>
#include <map>
#include <queue>
using namespace std;

char board[102][102];
int N;

void print() {
	for(int i=1; i<=N; i++) {
		for(int j=1; j<=N; j++) {		
			cerr << board[i][j];
		}
		cerr << endl;
	} 
	cerr << endl;
} 

// this program solves the Ga puzzle by keeping a queue of new w's 
int main() {
	int testcases, stones;
	queue< pair<int, int> > stateQueue;
	pair<int, int> temp, current;
	cin >> testcases;
	
	while(testcases--) { 
	
		// reset variables
		while(!stateQueue.empty())
			stateQueue.pop();
		memset(board, 0, sizeof(board));		

		cin >> N;
		
		// read input
		for(int i=1; i<=N; i++) {
			for(int j=1; j<=N; j++) {		
				cin >> board[i][j];
				if(board[i][j] == 'w') {
					temp.first = i;
					temp.second = j;
					stateQueue.push(temp);
				}
			}
		} 
		//print();
		
		// look at neighborhood of each w until there are no more new w's
		stones = 0;
		while(!stateQueue.empty()) {
		
			current = stateQueue.front();			
			stateQueue.pop();
			
			int i = current.first;
			int j = current.second;

			if(board[i][j+1] == '-') {
				board[i][j+1] = 'w';
				temp.first = i;
				temp.second = j+1;
				stateQueue.push(temp);
				stones++;
			}
			if(board[i][j-1] == '-') {
				board[i][j-1] = 'w';
				temp.first = i;
				temp.second = j-1;
				stateQueue.push(temp);
				stones++;
			}
			if(board[i+1][j] == '-') {
				board[i+1][j] = 'w';
				temp.first = i+1;
				temp.second = j;
				stateQueue.push(temp);
				stones++;
			}
			if(board[i-1][j] == '-') {
				board[i-1][j] = 'w';
				temp.first = i-1;
				temp.second = j;
				stateQueue.push(temp);
				stones++;
			}	
			if(board[i-1][j+1] == '-') {
				board[i-1][j+1] = 'w';
				temp.first = i-1;
				temp.second = j+1;
				stateQueue.push(temp);
				stones++;
			}
			if(board[i+1][j-1] == '-') {
				board[i+1][j-1] = 'w';
				temp.first = i+1;
				temp.second = j-1;
				stateQueue.push(temp);
				stones++;
			}
			if(board[i+1][j+1] == '-') {
				board[i+1][j+1] = 'w';
				temp.first = i+1;
				temp.second = j+1;
				stateQueue.push(temp);
				stones++;
			}
			if(board[i-1][j-1] == '-') {
				board[i-1][j-1] = 'w';
				temp.first = i-1;
				temp.second = j-1;
				stateQueue.push(temp);
				stones++;
			}					
						
		} // while queue is not empty
		
		cout << stones << endl;
		
	} // while
} // main
