import java.util.Scanner;


class Risk_JanE_AC {
	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int T = sc.nextInt();
		for (int tc=1; tc<=T; tc++) {
			int D = sc.nextInt();
			int nA = sc.nextInt(), nB = sc.nextInt();
			// p_tmp[mx][mx2][K] is the probability that, if P1's two best outcomes are mx >= mx2 and P2 uses two dice, P1 loses K times.
			double p_tmp[][][] = new double[D][D][3];
			for(int i=0;i<D;i++)for(int j=0;j<=i;j++){
				for(int x=0;x<D;x++)for(int y=0;y<D;y++){
					boolean win1=Math.max(x,y)>=i, win2=Math.min(x,y)>=j;
					if(win1&&win2)p_tmp[i][j][2]+=(double)1/D/D;
					else if(win1||win2)p_tmp[i][j][1]+=(double)1/D/D;
					else p_tmp[i][j][0]+=(double)1/D/D;
				}
			}
			// main dynamic programming table.
			double p[][] = new double[nA+1][nB+1];
			for (int i=1; i<=nA; i++) for (int j=0; j<=nB; j++) {
				if (i==1) p[i][j] = 0;
				else if (j==0) p[i][j] = 1;
				else {
					p[i][j] = 0;
					// attacker rolls min(3,A-1) dice.
					int n1 = Math.min(3,i-1);
					if (n1==1) {
						for(int v=0;v<D;v++){
							if(j==1) p[i][j] += (double)1/D * (p[i-1][j]*(1-(double)v/D) + p[i][j-1]*(double)v/D);
							else p[i][j] += (double)1/D * (p[i-1][j]*(1-(double)v*v/D/D) + p[i][j-1]*(double)v*v/D/D);
						}
					}else{
						double sumw=0;
						for(int mx=0;mx<D;mx++) for(int mx2=0;mx2<=mx;mx2++) {
							double w;
							if(n1==2)w=(double)(mx==mx2?1:2)/D/D;
							else {
								if(mx2<mx)w=(double)(6*mx2+3)/D/D/D;
								else w=(double)(3*mx+1)/D/D/D;
							}
							sumw+=w;
							// 1. defender rolls once.
							double opt = p[i-1][j]*(D-mx)/D + p[i][j-1]*mx/D;
							// 2. defender rolls twice.
							if(j>=2){
								opt = Math.min(opt, p[i-2][j]*p_tmp[mx][mx2][2] + p[i-1][j-1]*p_tmp[mx][mx2][1] + p[i][j-2]*p_tmp[mx][mx2][0]);
							}
							p[i][j] += opt*w;
						}
						assert Math.abs(sumw-1.0)<1e-9;
					}
				}
			}
			System.out.printf("%.4f\n",p[nA][nB]);
		}
	}
}
