import java.io.BufferedReader;
import java.io.InputStreamReader;


class Rummikub_jan_AC {

	private static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
	private static final int max_suits = 4;
	private static final int max_value = 101;
	
	public static void main(String[] args) throws Exception {
		int N = Integer.parseInt(br.readLine());
		
		for (int i = 0; i < N; ++i) {
			System.out.println( solve() );
		}
	}
	
	private static String solve() throws Exception {
		boolean[][] tiles = new boolean[max_suits][max_value];
		
		int M = Integer.parseInt(br.readLine());
		String[] tilesStr = br.readLine().split(" ");
		
		for (int i = 0; i < M; ++i) {
			int tileSuit = suitToIdx(tilesStr[i].charAt(tilesStr[i].length() - 1));
			int tileNumber = Integer.parseInt( tilesStr[i].substring(0, tilesStr[i].length() - 1) );
			
			tiles[tileSuit][tileNumber] = true;
		}
		
		for (int i = 0; i < max_value; ++i) {
			int cnt = 0;
			for (int j = 0; j < max_suits; ++j) {
				if (tiles[j][i]) {
					cnt++;
				} 
				if (cnt >= 3) return "YES";
			}
		}
		
		for (int i = 0; i < max_suits; ++i) {
			int cnt = 0;
			for (int j = 0; j < max_value; ++j) {
				if (tiles[i][j]) {
					cnt++;
				} else {
					cnt = 0;
				}
				
				if (cnt >= 3) {
					return "YES";
				}
			}
		}
		
		return "NO";
	}
	
	private static int suitToIdx(char suit) {
		if (suit == 'b') { return 0; }
		if (suit == 'g') { return 1; } 
		if (suit == 'r') { return 2; }
		return 3;
	}
}
