using System;
using System.Collections.Generic;

namespace DroppingCars
{
	public static class DroppingCars
	{
		private struct Pos
		{
			public Pos(int xp, int yp) { this.x = xp; this.y = yp; }
			public int x;
			public int y;
		}
		private static bool[] done;
		private static bool[] down;
		private static bool[] right;
		private static int n;
		private static int m;
		private static int pos(int x, int y)
		{
			return x + y * n;
		}
		private static void fill(int x, int y)
		{
			Stack<Pos> positions_to_visit = new Stack<Pos>();
			positions_to_visit.Push(new Pos(x, y));
			done[pos(x,y)] = true;
			while (positions_to_visit.Count > 0)
			{
				Pos current = positions_to_visit.Pop();
				int xn = current.x;
				int yn = current.y;
				if (xn < n-1 && right[pos(xn, yn)]) visit(xn+1, yn, positions_to_visit);
				if (xn >= 1 && right[pos(xn-1, yn)]) visit(xn-1, yn, positions_to_visit);
				if (yn < m-1 && down[pos(xn, yn)]) visit(xn, yn+1, positions_to_visit);
				if (yn >= 1 && down[pos(xn, yn-1)]) visit(xn, yn-1, positions_to_visit);
			}
		}
		private static void visit(int x, int y, Stack<Pos> positions_to_visit)
		{
			if (!done[pos(x,y)])
			{
				done[pos(x,y)] = true;
				positions_to_visit.Push(new Pos(x, y));
			}
		}
		public static int Main(string[] args)
		{
			int T = int.Parse(Console.ReadLine());
			for (int i = 0; i < T; i++)
			{
				string[] nextLine = Console.ReadLine().Split(new char[] {' '}, StringSplitOptions.RemoveEmptyEntries);
				if (nextLine.Length < 4)
				{ Console.WriteLine("HORRIBLENESS1"); Console.WriteLine(i); }
				n = int.Parse(nextLine[0]);
				m = int.Parse(nextLine[1]);
				int p = int.Parse(nextLine[2]);
				int c = int.Parse(nextLine[3]);
				
				done = new bool[n * m];
				down = new bool[n * m];
				right = new bool[n * m];
				
				List<Pos> chargedSquares = new List<Pos>();
				for (int j = 0; j < p; j++)
				{
					string[] nextLine2 = Console.ReadLine().Split(new char[] {' '}, StringSplitOptions.RemoveEmptyEntries);
					if (nextLine2.Length < 2)
					{ Console.WriteLine("HORRIBLENESS2"); Console.WriteLine(i); }
					int x = int.Parse(nextLine2[0]);
					int y = int.Parse(nextLine2[1]);
					
					chargedSquares.Add(new Pos(x, y));
				}
				
				for (int j = 0; j < c; j++)
				{
					string[] nextLine2 = Console.ReadLine().Split(new char[] {' '}, StringSplitOptions.RemoveEmptyEntries);
					if (nextLine2.Length < 3)
					{ Console.WriteLine("HORRIBLENESS3"); Console.WriteLine(i); }
					int x = int.Parse(nextLine2[0]);
					int y = int.Parse(nextLine2[1]);
					char d = nextLine2[2][0];
					
					if (d == 'U') down[pos(x, y)] = true;
					else if (d == 'R') right[pos(x, y)] = true;
					else { Console.WriteLine("HORRIBLENESS4"); }
				}

				for (int j = 0; j < chargedSquares.Count; j++)
				{
					Pos pos = chargedSquares[j];
					fill(pos.x, pos.y);
				}

				int counter = 0;
				for (int x = 0; x < n; x++)
				{
					for (int y = 0; y < m; y++)
					{
						if (!done[pos(x, y)])
						{
							counter++;
							fill(x, y);
						}
					}
				}
				
				Console.WriteLine(counter);
			}
			return 0;
		}
	}
}
