import java.util.ArrayList;
import java.util.Scanner;
import java.util.Stack;

class alex_AC {
	private static class Pos
	{
		public Pos(int xp, int yp) { this.x = xp; this.y = yp; }
		public int x;
		public int y;
	}
	private static int n;
	private static int m;
	private static int position(int x, int y)
	{
		return x + y * n;
	}
	private static void fill(int x, int y, boolean[] done, boolean[] down, boolean[] right)
	{
		Stack<Pos> positions_to_visit = new Stack<Pos>();
		positions_to_visit.push(new Pos(x, y));
		done[position(x,y)] = true;
		while (!positions_to_visit.empty())
		{
			Pos current = positions_to_visit.pop();
			int xn = current.x;
			int yn = current.y;
			if (xn < n-1 && right[position(xn, yn)]) visit(xn+1, yn, positions_to_visit, done);
			if (xn >= 1 && right[position(xn-1, yn)]) visit(xn-1, yn, positions_to_visit, done);
			if (yn < m-1 && down[position(xn, yn)]) visit(xn, yn+1, positions_to_visit, done);
			if (yn >= 1 && down[position(xn, yn-1)]) visit(xn, yn-1, positions_to_visit, done);
		}
	}
	private static void visit(int x, int y, Stack<Pos> positions_to_visit, boolean[] done)
	{
		if (!done[position(x,y)])
		{
			done[position(x,y)] = true;
			positions_to_visit.push(new Pos(x, y));
		}
	}
	public static void main(String[] args) {
		Scanner scanner = new Scanner(System.in);
		int T = scanner.nextInt();
		for (int i = 0; i < T; i++)
		{
			n = scanner.nextInt();
			m = scanner.nextInt();
			int p = scanner.nextInt();
			int c = scanner.nextInt();
				
			boolean done[] = new boolean[n * m];
			boolean down[] = new boolean[n * m];
			boolean right[] = new boolean[n * m];
				
			ArrayList<Pos> chargedSquares = new ArrayList<Pos>();
			for (int j = 0; j < p; j++)
			{
				int x = scanner.nextInt();
				int y = scanner.nextInt();
				
				chargedSquares.add(new Pos(x, y));
			}
				
			for (int j = 0; j < c; j++)
			{
				int x = scanner.nextInt();
				int y = scanner.nextInt();
				char d = scanner.next().charAt(0);
				
				if (d == 'U') down[position(x, y)] = true;
				else if (d == 'R') right[position(x, y)] = true;
				else { System.out.println("HORRIBLENESS4"); }
			}

			for (int j = 0; j < chargedSquares.size(); j++)
			{
				Pos pos = chargedSquares.get(j);
				fill(pos.x, pos.y, done, down, right);
			}

			int counter = 0;
			for (int x = 0; x < n; x++)
			{
				for (int y = 0; y < m; y++)
				{
					if (!done[position(x, y)])
					{
						counter++;
						fill(x, y, done, down, right);
					}
				}
			}
				
			System.out.println(counter);
		}
	}
}
