// @author Frank
// @opgave Godzilla

#include <cstring>
#include <iostream>
#include <vector>
#include <map>
#include <queue>
using namespace std;

/*
. empty
G ghost
X wall
P/Q Pacman1 Pacman2

multiple solutions possible...

*/

struct State {
	int ai, aj, bi, bj;
	char prevmove;
};

int w, l;
char board[52][52];
int depthof[52][52][52][52];
State prevstate[52][52][52][52];

void print(State state) {
	for(int i=1; i<=w; i++) {
		for(int j=1; j<=l; j++) {		
			if(i == state.ai && j == state.aj && i == state.bi && j == state.bj)
				cerr << 'R';
			else if(i == state.ai && j == state.aj)
				cerr << 'P';
			else if(i == state.bi && j == state.bj)
				cerr << 'Q';				
			else
				cerr << board[i][j];
		}
		cerr << endl;
	} 
	cerr << endl;
} 

int main() {
	int testcases;
	queue< State > stateQueue; // BFS queue for states	
	State state, current, solution, begin;
	string answer;
	
	cin >> testcases;
	while(testcases--) { 
		// reset variables
		while(!stateQueue.empty())
			stateQueue.pop();
		memset(board, 0, sizeof(board));		
		memset(depthof, -1, sizeof(depthof));						
		state.ai = state.aj = state.bi = state.bj = 0;
		cin >> w >> l;
		
		// read input
		for(int i=1; i<=w; i++) {
			for(int j=1; j<=l; j++) {		
				cin >> board[i][j];
				if(board[i][j] == 'P' && state.ai == 0) {
					state.ai = i;
					state.aj = j;
					board[i][j] = '.';
				}
				else if(board[i][j] == 'P' && state.bi == 0) {
					state.bi = i;
					state.bj = j;
					board[i][j] = '.';
				}
			}
		} 

		// initial state
		solution = begin = state;
		
		if(depthof[state.ai][state.aj][state.bi][state.bj] == -1) {
			depthof[state.ai][state.aj][state.bi][state.bj] = 0;
			stateQueue.push(state);
		}		
		
		// actual BFS computation
		while(!stateQueue.empty()) {
					
			// North
			current = stateQueue.front();			
			state = stateQueue.front();			
			if( ((state.ai-1 >0 && board[state.ai-1][state.aj] != 'G') ||
				(state.ai-1 ==0 && board[w][state.aj] != 'G')) &&
				((state.bi-1>0 && board[state.bi-1][state.bj] != 'G') ||
				(state.bi-1==0 && board[w][state.bj] != 'G'))) {
				
				if(state.ai-1 >0 && board[state.ai-1][state.aj] != 'X')
					state.ai = state.ai-1;
				else if(state.ai-1 ==0 && board[w][state.aj] != 'X')
					state.ai = w;	
							
				if(state.bi-1 >0 && board[state.bi-1][state.bj] != 'X')
					state.bi = state.bi-1;
				else if(state.bi-1 ==0 && board[w][state.bj] != 'X')
					state.bi = w;					
					
			}
			if(depthof[state.ai][state.aj][state.bi][state.bj] == -1) {
				state.prevmove = 'N';		
				depthof[state.ai][state.aj][state.bi][state.bj] = depthof[current.ai][current.aj][current.bi][current.bj]+1;
				prevstate[state.ai][state.aj][state.bi][state.bj] = current;
				if(state.ai == state.bi && state.aj == state.bj) {
					solution = state;
					break;
					//while(1) 1;
				}
				stateQueue.push(state);

			}
			
			// South
			current = stateQueue.front();						
			state = stateQueue.front();			
			if( ((state.ai+1<=w  && board[state.ai+1][state.aj]   != 'G') ||
				(state.ai+1>w    && board[1][state.aj]    != 'G')) &&
				((state.bi+1<=w && board[state.bi+1][state.bj] != 'G') ||
				(state.bi+1>w  && board[1][state.bj]  != 'G'))) {
				
				if(state.ai+1<=w && board[state.ai+1][state.aj] != 'X')
					state.ai = state.ai+1;
				else if(state.ai+1>w && board[1][state.aj] != 'X')
					state.ai = 1;	
							
				if(state.bi+1<=w && board[state.bi+1][state.bj] != 'X')
					state.bi = state.bi+1;
				else if(state.bi+1>w && board[1][state.bj] != 'X')
					state.bi = 1;					
			}
			if(depthof[state.ai][state.aj][state.bi][state.bj] == -1) {
				state.prevmove = 'S';
				depthof[state.ai][state.aj][state.bi][state.bj] = depthof[current.ai][current.aj][current.bi][current.bj]+1;
				prevstate[state.ai][state.aj][state.bi][state.bj] = current;				
				if(state.ai == state.bi && state.aj == state.bj) {
					solution = state;
					break;					
				}				
				stateQueue.push(state);
			}			
			
			// West
			current = stateQueue.front();						
			state = stateQueue.front();			
			if( ((state.aj-1 >0 && board[state.ai][state.aj-1] != 'G') ||
				(state.aj-1 ==0 && board[state.ai][l] != 'G')) &&
				((state.bj-1>0 && board[state.bi][state.bj-1] != 'G') ||
				(state.bj-1==0 && board[state.bi][l] != 'G'))) {
				
				if(state.aj-1 >0 && board[state.ai][state.aj-1] != 'X')
					state.aj = state.aj-1;
				else if(state.aj-1 ==0 && board[state.ai][l] != 'X')
					state.aj = l;	
							
				if(state.bj-1 >0 && board[state.bi][state.bj-1] != 'X')
					state.bj = state.bj-1;
				else if(state.bj-1 ==0 && board[state.bi][l] != 'X')
					state.bj = l;					
					
			}
			if(depthof[state.ai][state.aj][state.bi][state.bj] == -1) {
				state.prevmove = 'W';						
				depthof[state.ai][state.aj][state.bi][state.bj] = depthof[current.ai][current.aj][current.bi][current.bj]+1;
				prevstate[state.ai][state.aj][state.bi][state.bj] = current;				
				if(state.ai == state.bi && state.aj == state.bj) {
					solution = state;
					break;					
				}				
				stateQueue.push(state);
			}
			
			// East
			current = stateQueue.front();						
			state = stateQueue.front();			
			if( ((state.aj+1<=l  && board[state.ai][state.aj+1]   != 'G') ||
				(state.aj+1>l    && board[state.ai][1]    != 'G')) &&
				((state.bj+1<=l && board[state.bi][state.bj+1] != 'G') ||
				(state.bj+1>l  && board[state.bi][1]  != 'G'))) {
				
				if(state.aj+1<=l && board[state.ai][state.aj+1] != 'X')
					state.aj = state.aj+1;
				else if(state.aj+1>l && board[state.ai][1] != 'X')
					state.aj = 1;	
							
				if(state.bj+1<=l && board[state.bi][state.bj+1] != 'X')
					state.bj = state.bj+1;
				else if(state.bj+1>l && board[state.bi][1] != 'X')
					state.bj = 1;					
			}			
			if(depthof[state.ai][state.aj][state.bi][state.bj] == -1) {
				state.prevmove = 'E';					
				depthof[state.ai][state.aj][state.bi][state.bj] = depthof[current.ai][current.aj][current.bi][current.bj]+1;
				prevstate[state.ai][state.aj][state.bi][state.bj] = current;				
				if(state.ai == state.bi && state.aj == state.bj) {
					solution = state;
					break;					
				}				
				stateQueue.push(state);
			}			
			
			stateQueue.pop();
		}
		
		// show answer
		if(solution.ai == solution.bi && solution.aj == solution.bj) {
			cout << depthof[solution.ai][solution.aj][solution.bi][solution.bj];		
			cout << ' ';
			answer = "";
			while(!(solution.ai == begin.ai && solution.aj == begin.aj && solution.bi == begin.bi && solution.bj == begin.bj)) {
				answer = solution.prevmove + answer;
				//print(solution);
				solution = prevstate[solution.ai][solution.aj][solution.bi][solution.bj];				
			}
			cout << answer << endl;
		}
		else
			cout << "IMPOSSIBLE" << endl;
	} // while
} // main
