// Solution to problem `Song Titles'
// Order: probably N
//
// Rudy van Vliet, 7 September, 2015

#include<iostream>
#include<cstring>

using namespace std;

const char EOS = '\0';
const int MaxNameLength = 100000;
char name[MaxNameLength+1],
     anagram[MaxNameLength+1];
int frequency[26],        // number of occurrences of letter
    lettersFrequency[26], // (numbers of) letters with at least one occurrence,
                          // in the order of their numbers of occurrences 
    positionInFrequency[26]; // position of letter in lettersFrequency

//*************************************************************************

// Move letter on position i in lettersFrequency to the right,
// until it encounters a letter with the same or a lower frequency.
void moveRight (int i)
{ int letter1, letter2;

  while (i<25 &&
         frequency[lettersFrequency[i]]<frequency[lettersFrequency[i+1]])
  {
    letter1 = lettersFrequency[i];
    letter2 = lettersFrequency[i+1];
    lettersFrequency[i] = letter2;
    positionInFrequency[letter2] = i;
    lettersFrequency[i+1] = letter1;
    positionInFrequency[letter1] = i+1;
    i++;
  }

}  // moveRight

//*************************************************************************

int main()
{ int nInst, inst;
  int len,
      i,
      letter,
      firstletter, nextletter,
      remaininglen;

  cin >> nInst;
  for (inst=1;inst<=nInst;inst++)
  {
    cin >> name;

    len = strlen (name);

    for (letter=0;letter<26;letter++)
      frequency[letter] = 0;

    for (i=0;i<len;i++)
      frequency[name[i]-'a'] ++;

    for (letter=0;letter<26;letter++)
    { lettersFrequency[letter] = letter;
      positionInFrequency[letter] = letter;
    }

      // Use InsertionSort (insert from right to left) to sort letters
      // on their numbers of occurrences in name, i.e., on frequency[letter].
    for (i=25;i>=0;i--)
      moveRight (i);

    if (frequency[lettersFrequency[0]]>(len+1)/2)
      // most frequent letters occurs too often
      cout << "IMPOSSIBLE" << endl;
    else  // possible
    {
      firstletter = 0;  // first letter in lexicographic order: 'a'
      remaininglen = len;

      for (i=0;i<len;i++)
      {  // determine anagram[i]
        if (2*frequency[lettersFrequency[0]]==remaininglen+1)
           // we need to take the (unique) most frequent letter
          letter = lettersFrequency[0];
        else  // take the first possible letter in lexicographic order
        { while (frequency[firstletter]==0)
            firstletter++;

          if (i==0 || anagram[i-1]!=(char)('a'+firstletter))
            letter = firstletter;
          else
          { nextletter = letter+1;
            while (frequency[nextletter]==0)
              nextletter++;
            letter = nextletter;
          }
        }

        anagram[i] = (char) ('a'+letter);
        frequency[letter]--;
        moveRight (positionInFrequency[letter]);

        remaininglen--;
      }
      anagram[len] = EOS;

      cout << anagram << endl;
    }  // possible

      
  }

  return 0;

}
