#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <cctype>
#include <climits>
#include <cassert>

#include <vector>
#include <deque>
#include <queue>
#include <stack>
#include <list>
#include <set>
#include <map>
#include <string>

#include <iostream>
#include <sstream>

#include <utility>
#include <functional>
#include <limits>
#include <numeric>
#include <algorithm> 

using namespace std;

int D;
double Dd;
double prob[123][123];
double wprob1[21][21][21];
double wprob2[21][21][21][3];

void calcwprobs() {
	for (int a = 0; a <= D; a++)
	for (int b = 0; b <= D; b++)
	for (int c = 0; c <= D; c++) {
		wprob1[a][b][c] = 0.0;
		wprob2[a][b][c][0] = 0.0;
		wprob2[a][b][c][1] = 0.0;
		wprob2[a][b][c][2] = 0.0;
		int rolls[] = {a,b,c};
		sort(rolls, rolls+3);
		for (int d = 1; d <= D; d++) {
			if (d < rolls[2])
				wprob1[a][b][c] += 1/Dd;
			for (int e = 1; e <= D; e++) {
				if ((max(d,e) >= rolls[2]) && (min(d,e) >= rolls[1]))
					wprob2[a][b][c][0] += 1/(Dd * Dd);
				else if ((max(d,e) < rolls[2]) && (min(d,e) < rolls[1]))
					wprob2[a][b][c][2] += 1/(Dd * Dd);
				else
					wprob2[a][b][c][1] += 1/(Dd * Dd);
			}
		}
	}
}

void calcprob1(int i, int j) {
	double p = 0.0;	
	for (int a = 1; a <= D; a++) {
		if (j == 1) {
			p += wprob1[a][0][0] * prob[i][j-1] + (1.0 - wprob1[a][0][0]) * prob[i-1][j];
		} else {
			double p1 = wprob1[a][0][0] * prob[i][j-1] + (1.0 - wprob1[a][0][0]) * prob[i-1][j];
			//double p2 = 0.0;			
			double p2 = wprob2[a][0][0][1] * prob[i][j-1] + wprob2[a][0][0][0] * prob[i-1][j];
			p += min(p1,p2);
		}
	}
	prob[i][j] = p/Dd;
}

void calcprob2(int i, int j) {
	double p = 0.0;	
	for (int a = 1; a <= D; a++)
	for (int b = 1; b <= D; b++) {
		if (j == 1) {
			p += wprob1[a][b][0] * prob[i][j-1] + (1.0 - wprob1[a][b][0]) * prob[i-1][j];
		} else {
			double p1 = wprob1[a][b][0] * prob[i][j-1] + (1.0 - wprob1[a][b][0]) * prob[i-1][j];
			double p2 = wprob2[a][b][0][2] * prob[i][j-2] + wprob2[a][b][0][1] * prob[i-1][j-1] + wprob2[a][b][0][0] * prob[i-2][j];
			p += min(p1,p2);
		}
	}
	prob[i][j] = p/(Dd*Dd);
}

void calcprob3(int i, int j) {
	double p = 0.0;	
	for (int a = 1; a <= D; a++)
	for (int b = 1; b <= D; b++)
	for (int c = 1; c <= D; c++) {
		if (j == 1) {
			p += wprob1[a][b][c] * prob[i][j-1] + (1.0 - wprob1[a][b][c]) * prob[i-1][j];
		} else {
			double p1 = wprob1[a][b][c] * prob[i][j-1] + (1.0 - wprob1[a][b][c]) * prob[i-1][j];
			double p2 = wprob2[a][b][c][2] * prob[i][j-2] + wprob2[a][b][c][1] * prob[i-1][j-1] + wprob2[a][b][c][0] * prob[i-2][j];
			p += min(p1,p2);
		}
	}
	prob[i][j] = p/(Dd*Dd*Dd);
}

void doit() {
	int M, N;
	cin >> D >> M >> N;
	Dd = (double) D;
	calcwprobs();
	M--;
	for (int i = 1; i <= M; i++)
		prob[i][0] = 1.0;
	for (int j = 1; j <= N; j++)
		prob[0][j] = 0.0;
	for (int i = 1; i <= M; i++)
	for (int j = 1; j <= N; j++) {
		if (i == 1)		
			calcprob1(i,j);
		else if (i == 2)
			calcprob2(i,j);
		else
			calcprob3(i,j);
	}
	cout << prob[M][N] << '\n';	
}

int main () {
	int T;
	cin >> T;
	for (int t = 1; t <= T; t++) {
		doit();
	}
	return 0;
}

